<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\Pedido\Controllers; 

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Sup00300PedidoDeColetaPorRegiaoController extends \Zeedhi\Framework\Controller\Report
{
    protected $qr2Strategy;
    protected $stNomeRel;
    protected $stExtensao;
    protected $birtStrategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    
    
    public  function __construct($reportService, $qr2Strategy, $birtStrategy, $newCode, $environment, $connection,$dataSourceManager)
    {
        parent::__construct($reportService);
        $this->qr2Strategy = $qr2Strategy;
        $this->birtStrategy      = $birtStrategy;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        
        $row['P_NRORG'] = $this->environment->getNrOrg();
        
        
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        
        $tipoRelatorio = $row['STRATEGY'];

        if($tipoRelatorio == 'BIRT'){
            //Criação da lista para Região e Comprador
            if($row['CDREGIAO'] != 'T'){
                $nrlista = $this->criarListaValores($row['CDREGIAO']);   
                $row['CDREGIAO'] = "_NRLISTA=".$nrlista;
            }
            if($row['CDOPERADOR'] != 'T'){
                $nrlista = $this->criarListaValores($row['CDOPERADOR']);   
                $row['CDOPERADOR'] = "_NRLISTA=".$nrlista;
            }
            
            $paramRelatorio = array(
                        "NIVEL"        => "P_NIVEL",
                        "CDFILIPROC"   => "P_CDFILIPROC",
                        "CDFILIAL"     => "P_CDFILIAL",
                        "DTINICIAL"    => "P_DTINICIAL",
                        "DTFINAL"      => "P_DTFINAL",
                        "CDARVPRODINI" => "P_CDPRODINI",
                        "CDARVPRODFIN" => "P_CDPRODFIN",
                        "TPRODUTO"     => "P_TPRODUTO",
                        "P_NRORG"         => "P_NRORG",
                        "CDREGIAO"     => "L_CDREGIAO",
                        "CDOPERADOR"  => "L_CDCOMPRADOR",
            );

        }else {
            $row['CDREGIAO1'] = $row['CDREGIAO'];
            $row['CDREGIAO2'] = $row['CDREGIAO'];
            $row['CDREGIAO3'] = $row['CDREGIAO'];
            $row['CDREGIAO4'] = $row['CDREGIAO'];
            $row['CDREGIAO5'] = $row['CDREGIAO'];
            $row['CDREGIAO6'] = $row['CDREGIAO'];
            $row['CDREGIAO7'] = $row['CDREGIAO'];
            
            $row['CDOPERADOR1'] = $row['CDOPERADOR'];
            $row['CDOPERADOR2'] = $row['CDOPERADOR'];
            $row['CDOPERADOR3'] = $row['CDOPERADOR'];
            $row['CDOPERADOR4'] = $row['CDOPERADOR'];
            $row['CDOPERADOR5'] = $row['CDOPERADOR'];
            $row['CDOPERADOR6'] = $row['CDOPERADOR'];
            $row['CDOPERADOR7'] = $row['CDOPERADOR'];
            
            $paramRelatorio = array( 

                        "NIVEL"        => "P_NIVEL",
                        "CDFILIPROC"   => "P_CDFILIPROC",
                        "CDFILIAL"     => "P_CDFILIAL",
                        "DTINICIAL"    => "P_DTINICIAL",
                        "DTFINAL"      => "P_DTFINAL",
                        "DTINI"        => "P_DTINI",   
                        "DTFIM"        => "P_DTFIN", 
                        "CDARVPRODINI" => "P_CDPRODINI",
                        "CDARVPRODFIN" => "P_CDPRODFIN",
                        "TPRODUTO"     => "P_TPRODUTO",
                        "CDREGIAO"     => "L_CDREGIAO",
                        "CDREGIAO1"    => "L_CDREGIAO1",
                        "CDREGIAO2"    => "L_CDREGIAO2",
                        "CDREGIAO3"    => "L_CDREGIAO3",
                        "CDREGIAO4"    => "L_CDREGIAO4",
                        "CDREGIAO5"    => "L_CDREGIAO5",
                        "CDREGIAO6"    => "L_CDREGIAO6",
                        "CDREGIAO7"    => "L_CDREGIAO7",
                        "CDOPERADOR"  => "L_CDCOMPRADOR",
                        "CDOPERADOR1" => "L_CDCOMPRADOR1",
                        "CDOPERADOR2" => "L_CDCOMPRADOR2",
                        "CDOPERADOR3" => "L_CDCOMPRADOR3",
                        "CDOPERADOR4" => "L_CDCOMPRADOR4",
                        "CDOPERADOR5" => "L_CDCOMPRADOR5",
                        "CDOPERADOR6" => "L_CDCOMPRADOR6",
                        "CDOPERADOR7" => "L_CDCOMPRADOR7"
            );
            
            
        }
        // print_r($row).die();
        
        $this->reportMapping[$this->stNomeRel] =
            array(
                'strategy' => $tipoRelatorio,
                'parameterMapping' => $paramRelatorio
                );
    }
    
    //cria lista de valores recebendo string como parametro
    protected function criarListaValores($lista){
        $nrlista = $this->newCode->getCodeByTableName('LISTA', $this->environment->getNrOrg());
        $valores = explode('_',$lista);
        try{
            foreach($valores as $key){
                $this->insertLista($nrlista, $key);
            }
            return $nrlista;
        } catch(\Exception $e){
            throw $e;
        }
     }
    
    //insere lista no banco
    public function insertLista($nrlista, $cdlista) {
        $params = array(
            "NRLISTA" => $nrlista,
            "CDLISTA" => $cdlista
        );
        
        $sql = "INSERT INTO LISTA (NRLISTA, CDLISTA) VALUES (:NRLISTA, :CDLISTA)";
        $query = $this->connection->prepare($sql);
        $query->execute($params);
    }
}
