<?php

namespace Teknisa\SUP\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Method;
use Zeedhi\Framework\DataSource\DataSet;
use Exception;

class ParametrosSupplyTekController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $crudService;
    protected $dataSourceManager;
  	protected $connection;
	

    public function __construct($crudService,  $environment, $dataSourceManager, $connection) {
        $this->crudService       = $crudService;
        $this->environment       = $environment;
        $this->dataSourceManager = $dataSourceManager;
        $this->connection        = $connection;
    }
    
    public function saveSupplyTek(DTO\Request\Row $request, DTO\Response $response)
  	{
  		try {
        $row = $request->getRow();
  			$this->updateSupplyTek($row);
  			$response->addMessage(new Message("Operação realizada com sucesso."));
  		} catch (\Exception $e) {
  			$response->setError(new Error($e->getMessage(), 500));
  		}
  	}
	
    public function updateSupplyTek($row){
      $sql = "UPDATE PARASUPRI 
              SET IDALTERAQTDE   = :P_IDALTERAQTDE,
                  IDALTPRODAPROV = :P_IDALTPRODAPROV,
                  IDUTLORCAMENTO = :P_IDUTLORCAMENTO,
                  IDCONSVALPREC  = :P_IDCONSVALPREC 
              WHERE CDFILIAL = :P_CDFILIAL 
                AND NRORG    = :P_NRORG";
      $stmt = $this->connection->prepare($sql);
      $stmt->execute(
          array(
              'P_IDALTERAQTDE'   => $row['IDALTERAQTDE'],
              'P_IDALTPRODAPROV' => $row['IDALTPRODAPROV'],
              'P_IDUTLORCAMENTO' => $row['IDUTLORCAMENTO'],
              'P_IDCONSVALPREC'  => $row['IDCONSVALPREC'],
              'P_CDFILIAL'       => $row['CDFILIAL'],
              'P_NRORG'          => $this->environment->getNrorg()
          )   
      );
    }
    
}